---
title: Animation.onremove
slug: Web/API/Animation/onremove
tags:
  - API
  - Animation
  - Event Handler
  - Experimental
  - Property
  - Reference
  - onremove
  - web animations api
---
<p>{{ SeeCompatTable() }}{{ APIRef("Web Animations") }}</p>

<p>The {{domxref("Animation")}} interface's <code><strong>onremove</strong></code> property (from the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a>) is the event handler for the {{event("remove")}} event. This event is sent when the animation is removed (i.e., put into an <code>active</code> replace state).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>removeHandler</em> = <em>animation</em>.onremove;

<em>animation</em>.onremove = <em>removeHandler</em>;</pre>

<h3 id="Value">Value</h3>

<p>A function to be called to handle the {{event("remove")}} event, or <code>null</code> if no <code>remove</code> event handler is set.</p>

<h2 id="Examples">Examples</h2>

<p>In our simple <a href="https://mdn.github.io/dom-examples/web-animations-api/replace-indefinite-animations.html">replace indefinite animations demo</a>, you can see the following code:</p>

<pre class="brush: js">const divElem = document.querySelector('div');

document.body.addEventListener('mousemove', evt =&gt; {
  let anim = divElem.animate(
    { transform: `translate(${ evt.clientX}px, ${evt.clientY}px)` },
    { duration: 500, fill: 'forwards' }
  );

  anim.commitStyles();

  //anim.persist()

  anim.onremove = function() {
    console.log('Animation removed');
  }

  console.log(anim.replaceState);
});</pre>

<p>Here we have a <code>&lt;div&gt;</code> element, and an event listener that fires the event handler code whenever the mouse moves. The event handler sets up an animation that animates the &lt;div&gt; element to the position of the mouse pointer. This could result in a huge animations list, which could create a memory leak. For this reason, modern browsers automatically remove overriding forward filling animations.</p>

<p>A console message is logged each time an animation it removed, invoked when the <code>remove </code>event is fired.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#dom-animation-onremove', 'Animation.onremove' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Animation.onremove")}}</p>
</div>

<h2 id="See_also" style="line-height: 30px; font-size: 2.14285714285714rem;">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Animation")}}</li>
</ul>
